﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Advantage.Data.Provider;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private AdsConnection cn;
        private Int32 SpeciesNo;
        private Boolean IsDirty;


        public Form1()
        {
            InitializeComponent();
            cn = new AdsConnection("Data Source = C:\\ADSDB; TableType = ADT; ServerType = REMOTE; TrimTrailingSpaces = TRUE");
            cn.Open();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SpeciesNo = -1;
            ReadRecord(1);
        }

        private void ReadRecord(Int32 mode)
        {
            AdsCommand cmd = cn.CreateCommand();
            switch (mode)
            {
                case 0: //exact match if possible ... 
                    cmd.CommandText = "select top 1 * from biolife where [species no] = " + SpeciesNo.ToString() + " order by [species no]";
                    break;
                case 1: //next in resultset
                    cmd.CommandText = "select top 1 * from biolife where [species no] > " + SpeciesNo.ToString() + " order by [species no]";
                    break;
                case -1: //prev in resultset
                    cmd.CommandText = "select top 1 * from biolife where [species no] < " + SpeciesNo.ToString() + " order by [species no] desc";
                    break;
                case -10: //first record
                    cmd.CommandText = "select top 1 * from biolife order by [species no]";
                    break;
                case 10: //last record
                    cmd.CommandText = "select top 1 * from biolife order by [species no] desc";
                    break;
            }
            cmd.CommandType = CommandType.Text;
            AdsDataReader rdr = cmd.ExecuteReader();
            if (rdr.Read())
            {
                species_NoTextBox.Text = rdr["Species No"].ToString();
                SpeciesNo = System.Convert.ToInt32(rdr["Species No"].ToString());
                categoryTextBox.Text = rdr["Category"].ToString();
                common_NameTextBox.Text = rdr["Common_Name"].ToString();
                species_NameTextBox.Text = rdr["Species Name"].ToString();
                length__cm_TextBox.Text = rdr["length (cm)"].ToString();
                length_InTextBox.Text = rdr["length_in"].ToString();
                notesTextBox.Text = rdr["notes"].ToString();
            }
            else
            {
                species_NoTextBox.Text = "0";
                SpeciesNo = 0;
                categoryTextBox.Text = "<NULL>";
                common_NameTextBox.Text = "<NULL>";
                species_NameTextBox.Text = "<NULL>";
                length__cm_TextBox.Text = "0";
                length_InTextBox.Text = "0";
                notesTextBox.Text = "<NULL>";
            }
            IsDirty = false;
        }

        private void SaveRecord()
        {
            AdsCommand cmd = cn.CreateCommand();
            cmd.CommandText = "MERGE [biolife] ON ([Species No] = :p1) "+
                              "WHEN MATCHED THEN "+ 
                              "  UPDATE SET [Category] = :p2, [Common_Name] = :p3, [Species Name] = :p4, "+
                              "    [Length (cm)] = :p5, [Length_In] = :p6, [Notes] = :p7 "+
                              "WHEN NOT MATCHED THEN "+
                              "  INSERT ([Species No],[Category],[Common_Name],[Species Name], "+
                              "          [Length (cm)],[Length_In],[Notes]) " +
                              "  VALUES (:p11,:p12,:p13,:p14,:p15,:p16,:p17)";
            AdsParameter param;
            param = cmd.CreateParameter();
            param.ParameterName = "p1";
            param.Value = System.Convert.ToInt32(species_NoTextBox.Text);
            SpeciesNo = System.Convert.ToInt32(species_NoTextBox.Text);
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p2";
            param.Value = categoryTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p3";
            param.Value = common_NameTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p4";
            param.Value = species_NameTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p5";
            param.Value = System.Convert.ToDouble(length__cm_TextBox.Text);
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p6";
            param.Value = System.Convert.ToDouble(length_InTextBox.Text);
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p7";
            param.Value = notesTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p11";
            param.Value = System.Convert.ToInt32(species_NoTextBox.Text);
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p12";
            param.Value = categoryTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p13";
            param.Value = common_NameTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p14";
            param.Value = species_NameTextBox.Text;
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p15";
            param.Value = System.Convert.ToDouble(length__cm_TextBox.Text);
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p16";
            param.Value = System.Convert.ToDouble(length_InTextBox.Text);
            cmd.Parameters.Add(param);
            param = cmd.CreateParameter();
            param.ParameterName = "p17";
            param.Value = notesTextBox.Text;
            cmd.Parameters.Add(param);
            cmd.ExecuteNonQuery();
            ReadRecord(0);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            SaveRecord();
        }

        private void TextBox_TextChanged(object sender, EventArgs e)
        {
            IsDirty = true;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (IsDirty)
                SaveRecord();
            ReadRecord(-1);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (IsDirty)
                SaveRecord();
            ReadRecord(-10);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (IsDirty)
                SaveRecord();
            ReadRecord(1);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (IsDirty)
                SaveRecord();
            ReadRecord(10);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ReadRecord(0);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            ReadRecord(0);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            species_NoTextBox.Text = "0";
            SpeciesNo = 0;
            categoryTextBox.Text = "";
            common_NameTextBox.Text = "";
            species_NameTextBox.Text = "";
            length__cm_TextBox.Text = "0";
            length_InTextBox.Text = "0";
            notesTextBox.Text = "";
        }

        private void button9_Click(object sender, EventArgs e)
        {
            AdsCommand cmd = cn.CreateCommand();
            cmd.CommandText = "delete from biolife where [species no] = :p1";
            cmd.CommandType = CommandType.Text;
            AdsParameter param;
            param = cmd.CreateParameter();
            param.ParameterName = "p1";
            param.Value = System.Convert.ToInt32(species_NoTextBox.Text);
            cmd.Parameters.Add(param);
            cmd.ExecuteNonQuery();
            ReadRecord(1);
        }

    }
}
